/**
 * Copyright (c) 2018 CEA
 * 
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Jrmie Tatibouet (CEA) jeremie.tatibouet@cea.fr - Initial API and implementation
 *   Benoit Maggi (CEA) benoit.maggi@cea.fr - Initial API and implementation
 * 
 */
package  org.eclipse.papyrus.iotml.hardware.sensor;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.papyrus.iotml.hardware.sensor.SensorPackage
 * @generated
 */
public interface SensorFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SensorFactory eINSTANCE = org.eclipse.papyrus.iotml.hardware.sensor.impl.SensorFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Hw Common Sensor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hw Common Sensor</em>'.
	 * @generated
	 */
	HwCommonSensor createHwCommonSensor();

	/**
	 * Returns a new object of class '<em>Hw RFID Reader Sensor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hw RFID Reader Sensor</em>'.
	 * @generated
	 */
	HwRFIDReaderSensor createHwRFIDReaderSensor();

	/**
	 * Returns a new object of class '<em>Hw Tag</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hw Tag</em>'.
	 * @generated
	 */
	HwTag createHwTag();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	SensorPackage getSensorPackage();

} //SensorFactory
